﻿EnableExplicit

;Die Bass.dll für Einsteiger

;Gib mir BASS !!!
IncludeFile "bass.pbi"

;- Prototype Macros
Macro GetFunctionProtoQuote
  "
EndMacro
Macro GetFunctionProto(dll, name)
  Global name.name
  name = GetFunction(dll, GetFunctionProtoQuote#name#GetFunctionProtoQuote)
  CompilerIf #PB_Compiler_Debugger  ; Only enable assert in debug mode
    If name = #Null
      Debug "Assert on line " + #PB_Compiler_Line + ", GetFunction(" + GetFunctionProtoQuote#dll#GetFunctionProtoQuote + ", " + GetFunctionProtoQuote#name#GetFunctionProtoQuote + ")"
    EndIf
  CompilerEndIf
EndMacro

; BASS_Load_Library
Threaded _BASS_Load_Library_DLL_.i

Procedure BASS_Free_Library()
  If IsLibrary(_BASS_Load_Library_DLL_)
    CloseLibrary(_BASS_Load_Library_DLL_)
  EndIf
EndProcedure


Procedure.i BASS_Load_Library(dllpath$)
  Protected dll.i, result.i
  
  If IsLibrary(_BASS_Load_Library_DLL_)
    ProcedureReturn #False
  EndIf
  
  _BASS_Load_Library_DLL_ = OpenLibrary(#PB_Any, dllpath$)
  dll = _BASS_Load_Library_DLL_
  If IsLibrary(dll) = #False
    
    ProcedureReturn #False
  EndIf
  
  GetFunctionProto(dll, BASS_GetVersion)
  If BASS_GetVersion = #Null
    ;BASS_GetVersion() not found, is this really bass.dll ?
    BASS_Free_Library()
    
    ProcedureReturn #False
  EndIf
  
  ;Make sure BASS API and bass.dll are compatible.
  result = BASS_GetVersion()
  If (result & $FFFF0000) <> (#BASSVERSION & $FFFF0000) Or (result < #BASSVERSION)
    BASS_Free_Library()
    
    ProcedureReturn #False
  EndIf
  
  ;You should only use the GetFunctionProto() for the BASS functions you actually need/use,
  ;these are macros thus you will save some memory/exe size by removing the functions you don't use,
  ;during debugging the GetFunctionProto() macro will also check if the BASS function exists in the loaded library to catch wrong library versions.
  GetFunctionProto(dll, BASS_SetConfig)
  GetFunctionProto(dll, BASS_GetConfig)
  GetFunctionProto(dll, BASS_SetConfigPtr)
  GetFunctionProto(dll, BASS_GetConfigPtr)
  GetFunctionProto(dll, BASS_ErrorGetCode)
  GetFunctionProto(dll, BASS_GetDeviceInfo)
  GetFunctionProto(dll, BASS_Init)
  GetFunctionProto(dll, BASS_SetDevice)
  GetFunctionProto(dll, BASS_GetDevice)
  GetFunctionProto(dll, BASS_Free)
  ;GetFunctionProto(dll, BASS_GetDSoundObject)
  GetFunctionProto(dll, BASS_GetInfo)
  GetFunctionProto(dll, BASS_Update)
  GetFunctionProto(dll, BASS_GetCPU)
  GetFunctionProto(dll, BASS_Start)
  GetFunctionProto(dll, BASS_Stop)
  GetFunctionProto(dll, BASS_Pause)
  GetFunctionProto(dll, BASS_SetVolume)
  GetFunctionProto(dll, BASS_GetVolume)
  
  GetFunctionProto(dll, BASS_PluginLoad)
  GetFunctionProto(dll, BASS_PluginFree)
  GetFunctionProto(dll, BASS_PluginGetInfo)
  
  GetFunctionProto(dll, BASS_Set3DFactors)
  GetFunctionProto(dll, BASS_Get3DFactors)
  GetFunctionProto(dll, BASS_Set3DPosition)
  GetFunctionProto(dll, BASS_Get3DPosition)
  GetFunctionProto(dll, BASS_Apply3D)
  CompilerIf #PB_Compiler_OS = #PB_OS_Windows
    GetFunctionProto(dll, BASS_SetEAXParameters)
    GetFunctionProto(dll, BASS_GetEAXParameters)
  CompilerEndIf
  
  GetFunctionProto(dll, BASS_MusicLoad)
  GetFunctionProto(dll, BASS_MusicFree)
  
  GetFunctionProto(dll, BASS_SampleLoad)
  GetFunctionProto(dll, BASS_SampleCreate)
  GetFunctionProto(dll, BASS_SampleFree)
  GetFunctionProto(dll, BASS_SampleSetData)
  GetFunctionProto(dll, BASS_SampleGetData)
  GetFunctionProto(dll, BASS_SampleGetInfo)
  GetFunctionProto(dll, BASS_SampleSetInfo)
  GetFunctionProto(dll, BASS_SampleGetChannel)
  GetFunctionProto(dll, BASS_SampleGetChannels)
  GetFunctionProto(dll, BASS_SampleStop)
  
  GetFunctionProto(dll, BASS_StreamCreate)
  GetFunctionProto(dll, BASS_StreamCreateFile)
  GetFunctionProto(dll, BASS_StreamCreateURL)
  GetFunctionProto(dll, BASS_StreamCreateFileUser)
  GetFunctionProto(dll, BASS_StreamFree)
  GetFunctionProto(dll, BASS_StreamGetFilePosition)
  GetFunctionProto(dll, BASS_StreamPutData)
  GetFunctionProto(dll, BASS_StreamPutFileData)
  
  GetFunctionProto(dll, BASS_RecordGetDeviceInfo)
  GetFunctionProto(dll, BASS_RecordInit)
  GetFunctionProto(dll, BASS_RecordSetDevice)
  GetFunctionProto(dll, BASS_RecordGetDevice)
  GetFunctionProto(dll, BASS_RecordFree)
  GetFunctionProto(dll, BASS_RecordGetInfo)
  GetFunctionProto(dll, BASS_RecordGetInputName)
  GetFunctionProto(dll, BASS_RecordSetInput)
  GetFunctionProto(dll, BASS_RecordGetInput)
  GetFunctionProto(dll, BASS_RecordStart)
  
  GetFunctionProto(dll, BASS_ChannelBytes2Seconds)
  GetFunctionProto(dll, BASS_ChannelSeconds2Bytes)
  GetFunctionProto(dll, BASS_ChannelGetDevice)
  GetFunctionProto(dll, BASS_ChannelSetDevice)
  GetFunctionProto(dll, BASS_ChannelIsActive)
  GetFunctionProto(dll, BASS_ChannelGetInfo)
  GetFunctionProto(dll, BASS_ChannelGetTags)
  GetFunctionProto(dll, BASS_ChannelFlags)
  GetFunctionProto(dll, BASS_ChannelUpdate)
  GetFunctionProto(dll, BASS_ChannelLock)
  GetFunctionProto(dll, BASS_ChannelPlay)
  GetFunctionProto(dll, BASS_ChannelStop)
  GetFunctionProto(dll, BASS_ChannelPause)
  GetFunctionProto(dll, BASS_ChannelSetAttribute)
  GetFunctionProto(dll, BASS_ChannelSetAttributeEx)
  GetFunctionProto(dll, BASS_ChannelGetAttribute)
  GetFunctionProto(dll, BASS_ChannelGetAttributeEx)
  GetFunctionProto(dll, BASS_ChannelSlideAttribute)
  GetFunctionProto(dll, BASS_ChannelIsSliding)
  GetFunctionProto(dll, BASS_ChannelSet3DAttributes)
  GetFunctionProto(dll, BASS_ChannelGet3DAttributes)
  GetFunctionProto(dll, BASS_ChannelSet3DPosition)
  GetFunctionProto(dll, BASS_ChannelGet3DPosition)
  GetFunctionProto(dll, BASS_ChannelGetLength)
  GetFunctionProto(dll, BASS_ChannelSetPosition)
  GetFunctionProto(dll, BASS_ChannelGetPosition)
  GetFunctionProto(dll, BASS_ChannelGetLevel)
  GetFunctionProto(dll, BASS_ChannelGetLevelEx)
  GetFunctionProto(dll, BASS_ChannelGetData)
  GetFunctionProto(dll, BASS_ChannelSetSync)
  GetFunctionProto(dll, BASS_ChannelRemoveSync)
  GetFunctionProto(dll, BASS_ChannelSetDSP)
  GetFunctionProto(dll, BASS_ChannelRemoveDSP)
  GetFunctionProto(dll, BASS_ChannelSetLink)
  GetFunctionProto(dll, BASS_ChannelRemoveLink)
  GetFunctionProto(dll, BASS_ChannelSetFX)
  GetFunctionProto(dll, BASS_ChannelRemoveFX)
  
  GetFunctionProto(dll, BASS_FXSetParameters)
  GetFunctionProto(dll, BASS_FXGetParameters)
  GetFunctionProto(dll, BASS_FXReset)
  ProcedureReturn #True
EndProcedure

CompilerIf #PB_Compiler_OS = #PB_OS_Linux
  If BASS_Load_Library("libbass.so") = #False
    Debug "bass.dll kann nicht geladen werden."
    End
  EndIf
CompilerElse
  If BASS_Load_Library("bass.dll") = #False
    Debug "bass.dll kann nicht geladen werden."
    End
  EndIf
CompilerEndIf


;- Hier geht es los!

;Wir legen ein Bass-Handle fest.
Global Handle

Global key.s ;ANY KEY ;)
Global fPos  ;Abspielposition
Global stereo, active, ende

;Wir sagen mal Hallo und legen unsere Grundeinstellungen fest.
BASS_Init(-1,44100,#BASS_DEVICE_3D,#Null,#Null)
;BASS_Apply3D()
BASS_SetConfig(#BASS_CONFIG_UNICODE, #True)

;Wir legen die Abspiellautstärke fest.
BASS_SetVolume(50)

;Falls hier mysteriöser Weise schon ein Handle existiert.
BASS_StreamFree(Handle)

;Wir öffnen eine Dateiauswahl.
Global Filename.s = OpenFileRequester("","","Musik|*.mp3;*.wav",0)

If Filename <> ""  
  OpenConsole()
  EnableGraphicalConsole(1)
  PrintN("Wähle ein Soundprofil:")
  PrintN("1 = Stereo")
  PrintN("2 = 5.1 Sound (muss aktiviert sein)")
  Repeat
    key = Inkey()
    If key = Chr(49)
      stereo = #True
      active = #True
      PrintN("Wähle eine Soundposition:")
      PrintN("1 = FRONT-LEFT")
      PrintN("2 = FRONT-RIGHT")
    ElseIf key = Chr(50)
      stereo = #False
      active = #True
      PrintN("Wähle eine Soundposition:")
      PrintN("1 = FRONT-LEFT")
      PrintN("2 = FRONT-RIGHT")
      PrintN("3 = CENTER")
      PrintN("4 = BACK-LEFT")
      PrintN("5 = BACK-RIGHT")
    EndIf
  Until active = #True And Len(key) > 0
  
  ;Hier wird eine Musikdatei an Bass übergeben.
  ;(Wenn hier eine falsche/oder keine Datei übergeben wird ist das Programm an diesem Punkt zu ende.)
  
  If active = #True
    Repeat
      key = Inkey()
      If Len(key) > 0
        BASS_ChannelStop(Handle)
        BASS_StreamFree(Handle)
        If key = Chr(27)
          ende = #True
        ElseIf key = Chr(49) And stereo = #True
          Handle = BASS_StreamCreateFile(#False, UTF8(Filename), 0, 0, #BASS_SPEAKER_FRONTLEFT | #BASS_SAMPLE_MONO)
          If Handle
            BASS_ChannelPlay(Handle,0)
          EndIf
        ElseIf key = Chr(50) And stereo = #True
          Handle = BASS_StreamCreateFile(#False, UTF8(Filename), 0, 0, #BASS_SPEAKER_FRONTRIGHT | #BASS_SAMPLE_MONO)
          If Handle
            BASS_ChannelPlay(Handle,0)
          EndIf
        ElseIf key = Chr(49) And stereo = #False
          Handle = BASS_StreamCreateFile(#False, UTF8(Filename), 0, 0, #BASS_SPEAKER_FRONTLEFT | #BASS_SAMPLE_MONO)
          If Handle
            BASS_ChannelPlay(Handle,0)
          EndIf
        ElseIf key = Chr(50) And stereo = #False
          Handle = BASS_StreamCreateFile(#False, UTF8(Filename), 0, 0, #BASS_SPEAKER_FRONTRIGHT | #BASS_SAMPLE_MONO)
          If Handle
            BASS_ChannelPlay(Handle,0)
          EndIf
        ElseIf key = Chr(51) And stereo = #False
          Handle = BASS_StreamCreateFile(#False, UTF8(Filename), 0, 0, #BASS_SPEAKER_CENTER | #BASS_SAMPLE_MONO)
          If Handle
            BASS_ChannelPlay(Handle,0)
          EndIf
        ElseIf key = Chr(52) And stereo = #False
          Handle = BASS_StreamCreateFile(#False, UTF8(Filename), 0, 0, #BASS_SPEAKER_REARLEFT | #BASS_SAMPLE_MONO)
          If Handle
            BASS_ChannelPlay(Handle,0)
          EndIf
        ElseIf key = Chr(53) And stereo = #False
          Handle = BASS_StreamCreateFile(#False, UTF8(Filename), 0, 0, #BASS_SPEAKER_REARRIGHT| #BASS_SAMPLE_MONO)
          If Handle
            BASS_ChannelPlay(Handle,0)
          EndIf
        EndIf
      EndIf
      ;Abspielposition anzeigen:
      If Handle And BASS_ChannelIsActive(Handle) = #BASS_ACTIVE_PLAYING
        fPos = BASS_StreamGetFilePosition(Handle,#BASS_FILEPOS_CURRENT)
        ConsoleLocate(0, 15)
        Print("Musik-Position: " + Str(fPos))
      EndIf
    Until ende = #True
  EndIf
EndIf
;Bass beenden!!!
BASS_Free()
CloseConsole()
; IDE Options = PureBasic 5.61 (Linux - x64)
; CursorPosition = 297
; FirstLine = 264
; Folding = --
; EnableXP
; Executable = ok.exe
; Debugger = Console